sub run_monitor
#----------------------------------------------------------------------
#
# Run monitoring functions
#
#----------------------------------------------------------------------
{
  ($routine) = @_;
  $this_function = $routine;

  my $msg; 

  &heartbeat; 

  $wheretolog = "D";
  $s_flag = "Y";
  $i_rm = 1;

  $msg = sprintf("---------------------------------------------------");
  &logit($msg);

  if ($routine eq "infNFile")
  {
    $s_title = "NFile";
    $msg = sprintf("Informix - Checking UX NFILE Kernel Parm ...");
    &logit($msg);
  }

  if ($routine eq "infLongTX")
  {
    $s_title = "LongTx";
    $msg = sprintf("Informix - Checking for Long Transactions ...");
    &logit($msg);
  }

  if ($routine eq "infChkDup")
  {
    $s_title = "Dup";
    $msg = sprintf("Informix - Checking for Duplicate ONCONFIG Parms ...");
    &logit($msg);
  }

  if ($routine eq "infHDR")
  {
    $s_title = "HDR";
    $msg = sprintf("Informix - Checking HDR ...");
    &logit($msg);
  }

  if ($routine eq "infDBS")
  {
    $s_title = "DBSpaces";
    $msg = sprintf("Informix - Checking for full DBSpaces ...");
    &logit($msg);
  }

  if ($routine eq "infSWVer")
  {
    $s_title = "Informix Version Mgmt.";
    $msg = sprintf("Informix - Checking Version ...");
    &logit($msg);
  }

  if ($routine eq "DownloadSW")
  {
    $s_title = "Software Download";
    $msg = sprintf("(All DBMSs) - Downloading DBAmon Software ...");
    &logit($msg);
  }

  if ($routine eq "infUp")
  {
    $s_title = "Informix On-Line";
    $msg = sprintf("Informix - Instance active ...");
    &logit($msg);
  }

  if ($routine eq "infSaveCfg")  
  { 
    $s_title = "Save Configuration";
    $msg = sprintf("Informix - Saving Configuration Information ...");
    &logit($msg);
  }

  if ($routine eq "oraSaveCfg")  
  { 
    $s_title = "Save init.ora Configuration";
    $msg = sprintf("Oracle - Saving init.ora Information ...");
    &logit($msg);
  }

  if ($routine eq "infLlogs")    
  {
    $s_title = "Logical Logs Full";
    $msg = sprintf("Informix - Checking for full logical log files ...");
    &logit($msg);
  }

  if ($routine eq "infMLog")      
  {
    $s_title = "Error onstat -m Messages";
    $msg = sprintf("Informix - Checking for log messages ...");
    &logit($msg);
  }

  if ($routine eq "infPerf")    
  {
    $s_title = "Performance Data";
    $msg = sprintf("Informix - Checking performance metrics ...");
    &logit($msg);
  }

  if ($routine eq "infChunksDown")  
  {
    $s_title = "Down Chunks";
    $msg = sprintf("Informix - Checking for down chunks ...");
    &logit($msg);
  }

  if ($routine eq "infArc")      
  {
    $s_title = "Archive Age";
    $msg = sprintf("Informix - Checking archive age ...");
    &logit($msg);
  }

  if ($routine eq "infExtents")  
  {
    $s_title = "Table Extents";
    $msg = sprintf("Informix - Checking table extents ...");
    &logit($msg);
  }

  if ($routine eq "infCkpt")  
  {
    $s_title = "Informix - Checkpoint Duration";
    $msg = sprintf("Informix - Excessive Checkpoint duration ...");
    &logit($msg);
  }

  if ($routine eq "infLocks")  
  {
    $s_title = "Informix - Locks Used";
    $msg = sprintf("Informix - Checking locks used ...");
    &logit($msg);
  }

  if ($routine eq "infShmem")  
  {
    $s_title = "V Shared Memory";
    $msg = sprintf("Informix - Checking Shared Memory V Segments ...");
    &logit($msg);
  }

  if ($routine eq "infCleaners")  
  {
    $s_title = "CLEANERS";
    $msg = sprintf("Informix - Checking CLEANERS ...");
    &logit($msg);
  }

  if ($routine eq "orantUp")  
  {
    $s_title = "Oracle/NT UP";
    $msg = sprintf("Oracle/NT - Up ...");
    &logit($msg);
  }

  if ($routine eq "orantTSFull")  
  {
    $s_title = "Oracle/NT TS Full";
    $msg = sprintf("Oracle/NT - Tablespaces ...");
    &logit($msg);
  }

  if ($routine eq "orantArclog")  
  {
    $s_title = "Oracle/NT Arclog Disk ";
    $msg = sprintf("Oracle/NT - Arclog Disk Full ...");
    &logit($msg);
  }

  if ($routine eq "orantBkup")  
  {
    $s_title = "Oracle/NT Backup Age";
    $msg = sprintf("Oracle/NT - Backup Age ...");
    &logit($msg);
  }

  if ($routine eq "orantPerf")  
  {
    $s_title = "Oracle/NT Performance";
    $msg = sprintf("Oracle/NT - Performance ...");
    &logit($msg);
  }

  if ($routine eq "orantPerf2")  
  {
    $s_title = "Oracle/NT Performance2";
    $msg = sprintf("Oracle/NT - Performance2 ...");
    &logit($msg);
  }

  #---- SQL 

  if ($routine eq "sqlUp")  
  {
    $s_title = "MSSQL UP";
    $msg = sprintf("$routine - MSSQL - Up ...");
    &logit($msg);
  }

  if ($routine eq "sqlTLog")  
  {
    $s_title = "MSSQL TLog";
    $msg = sprintf("$routine - MSSQL - TLog ...");
    &logit($msg);
  }

  if ($routine eq "sqlBkup")  
  {
    $s_title = "MSSQL DB Backup Age";
    $msg = sprintf("$routine - MSSQL - DB Backup Age ...");
    &logit($msg);
  }

  if ($routine eq "sqlBkupTLog")  
  {
    $s_title = "MSSQL TLOG Backup Age";
    $msg = sprintf("$routine - MSSQL - TLog Backup Age ...");
    &logit($msg);
  }

  if ($routine eq "sqlAlerts")  
  {
    $s_title = "MSSQL Alerts";
    $msg = sprintf("$routine - MSSQL - Alerts ...");
    &logit($msg);
  }

  if ($routine eq "sqlFG")  
  {
    $s_title = "MSSQL Filegroups";
    $msg = sprintf("$routine - MSSQL - Filegroups ...");
    &logit($msg);
  }

  if ($routine eq "sqlPerf")  
  {
    $s_title = "MSSQL Performance";
    $msg = sprintf("$routine - MSSQL - Performance ...");
    &logit($msg);
  }

  if ($routine eq "sqlJobs")  
  {
    $s_title = "MSSQL Jobs";
    $msg = sprintf("$routine - MSSQL - Jobs ...");
    &logit($msg);
  }

  if ($routine eq "sqlTrends")  
  {
    $s_title = "MSSQL Trends";
    $msg = sprintf("$routine - MSSQL - Trends ...");
    &logit($msg);
  }

  if ($routine eq "sqlSaveConfig")  
  {
    $s_title = "MSSQL Save Config";
    $msg = sprintf("$routine - MSSQL - Save Config ...");
    &logit($msg);
  }

  #---- SAP

  if ($routine eq "sapUp")  
  {
    $s_title = "SAP UP";
    &logit("SAP - Up ...");
  }

  if ($routine eq "oraapUp")  
  {
    $s_title = "OracleApps UP";
    $msg = sprintf("OracleApps - Up ...");
    &logit($msg);
  }

  if ($routine eq "oraUp")  
  {
    $s_title = "Oracle UP";
    $msg = sprintf("Oracle - Up ...");
    &logit($msg);
  }

  if ($routine eq "oraSec")  
  {
    $s_title = "Oracle Security";
    $msg = sprintf("Oracle - Security ...");
    &logit($msg);
  }

  if ($routine eq "oraBkup")  
  {
    $s_title = "Oracle Bkups";
    $msg = sprintf("Oracle - RMAN Backup Age ...");
    &logit($msg);
  }

  if ($routine eq "oraBkupArc")  
  {
    $s_title = "Oracle Arc Bkups";
    $msg = sprintf("Oracle - RMAN Arc Backup Age ...");
    &logit($msg);
  }

  if ($routine eq "oraArclog")  
  {
    $s_title = "Oracle Arclogs";
    $msg = sprintf("Oracle - Arclogs ...");
    &logit($msg);
  }

  if ($routine eq "oraPerf")  
  {
    $s_title = "Oracle Performance";
    $msg = sprintf("Oracle - Performance ...");
    &logit($msg);
  }

  if ($routine eq "oraExtents")  
  {
    $s_title = "Oracle Extents";
    $msg = sprintf("Oracle - Extents ...");
    &logit($msg);
  }

  if ($routine eq "oraAlerts")  
  {
    $s_title = "Oracle Alert Log";
    $msg = sprintf("Oracle - Alert Log ...");
    &logit($msg);
  }

  if ($routine eq "oraLsnr")  
  {
    $s_title = "Oracle Listener UP";
    $msg = sprintf("Oracle - Listener Up ...");
    &logit($msg);
  }

  if ($routine eq "oraAuditSes")  
  {
    $s_title = "Oracle Session Audit";
    $msg = sprintf("Oracle - Session Audit ...");
    &logit($msg);
  }

  if ($routine eq "oraSGA")  
  {
    $s_title = "Oracle SGA";
    $msg = sprintf("Oracle - SGA Full ...");
    &logit($msg);
  }

  if ($routine eq "oraInSync")  
  {
    $s_title = "Oracle Standby Synchronization";
    $msg = sprintf("Oracle - Standby Synchronization ...");
    &logit($msg);
  }

  if ($routine eq "oraDatafiles" || $routine eq "orantDatafiles")  
  {
    $s_title = "Oracle Datafile Check";
    $msg = sprintf("%s - Checking For OFFLINE Oracle Datafiles ...",$routine);
    &logit($msg);
  }

  if ($routine eq "oraTSFull")  
  {
    $s_title = "Oracle Tablespaces Full";
    $msg = sprintf("Oracle - Checking Tablespaces (Full) ...");
    &logit($msg);
  }

  if ($routine eq "osWinUp")  
  {
    $s_title = "OS=Windows Up";
    $msg = sprintf("OS=Windows - Up ...");
    &logit($msg);
  }
  if ($routine eq "osWinPerf")  
  {
    $s_title = "OS=Windows Performance";
    $msg = sprintf("OS=Windows - Performance ...");
    &logit($msg);
  }

  $msg = sprintf("---------------------------------------------------");
  &logit($msg);

  $section_start = time();

  $wheretolog = "S";
  &logit("Section $routine Starting - $s_title");
  $wheretolog = "";

  while ($i_rm <= $high_host) 
  {
    #---- For every instance create a dummy INS history entry
    $hist_row_inserted = 0; 
    &histCreate("run_monitor()",$i_rm,"INS",".",0,0);

    #---- FUTURE - Check to see if we will run on THIS ITERATION for THIS INSTANCE
    $ib_mins = &instanceBookmarkCheck($i_rm); 
    #print "DEBUG - ib_mins=$ib_mins\n"; 
    #---- 

    #---- Since we are continuing, record a row in INSTANCE_BOOKMARK table - New 2014/01/08
    &instanceBookmarkInsert($i_rm) if $routine =~ /^download/i; 

    #---- Place for daily reports - Only run if histCreate DID create a row (once per day)
    if ($hist_row_inserted == 1 || ($ENV{'DBAMON_FORCE_REPORT'} && $routine eq "sqlUp"))
    {
      &logit("Instance Reporting Starting",$i_rm);
      ##system("/opt/dbamon/bin/dbamon_daily_report $mode $hostfix[$i_rm] $serverloc[$i_rm] $instance[$i_rm] $dbcfile[$i_rm] $titleraw[$i_rm] $dbcfilenameshort[$i_rm] > /opt/dbamon/log/dbamon_daily_report/${hostfix[$i_rm]}_${instance[$i_rm]}.log 2>&1");  
      if (! -e "/opt/dbamon/log/dbamon_instance_report") { mkdir "/opt/dbamon/log/dbamon_instance_report"; } 
      system("/opt/dbamon/bin/dbamon_instance_report $mode $hostfix[$i_rm] $serverloc[$i_rm] $dbcfile[$i_rm] $titleraw[$i_rm] > /opt/dbamon/log/dbamon_instance_report/${mode}_${titleraw[$i_rm]}.log 2>&1");  
    }

    #---- If no monitoring for this instance, don't do anything
    if ($runmon[$i_rm] eq "N")   
    {
      &history_dummy($i_rm);
      &logDetails($i_rm,"<h5>No Detailed Data Available (DBC Monitor: N)</h5>");
      $i_rm++;
      next;
    }

    #---- Start timer to track time spend on this instance
    $instance_start = time();

    ##print "i=$title[$i_rm] f=$routine dbms=$dbms[$i_rm] \n";

    #---- Log Start msg
    &logit("RM_Start - $routine", $i_rm);
 
    #
    # Backup age monitoring only
    #
    if ($runmon[$i_rm] eq "B")   
    {
      if ($routine eq "DownloadSW") { &DownloadSW($i_rm) }
      # Oracle
      if ($routine eq "oraUp"      && $dbms[$i_rm]  eq  "Oracle")   {     oraUp($i_rm) }
      if ($routine eq "oraTSFull"  && $dbms[$i_rm]  eq  "Oracle")   { oraTSFull($i_rm) }
      if ($routine eq "oraArclog"  && $dbms[$i_rm]  eq  "Oracle")   { oraArclog($i_rm) }
      if ($routine eq "oraBkup"    && $dbms[$i_rm]  eq  "Oracle")   {   oraBkup($i_rm) }
      if ($routine eq "oraBkupArc" && $dbms[$i_rm]  eq  "Oracle")   {oraBkupArc($i_rm) }
      if ($routine eq "oraInSync"  && $dbms[$i_rm]  eq  "Oracle")   { oraInSync($i_rm) }
      # Informix
      if ($routine eq "infUp"      && $dbms[$i_rm]  eq  "Informix") {     infUp($i_rm) }
      if ($routine eq "infLlogs"   && $dbms[$i_rm]  eq  "Informix") {  infLlogs($i_rm) }
      if ($routine eq "infArc"     && $dbms[$i_rm]  eq  "Informix") {    infArc($i_rm) }
      # MSSQL
      if ($routine eq "sqlUp"      && $dbms[$i_rm]  eq  "MSSQL")    {     sqlUp($i_rm) }
      if ($routine eq "sqlTLog"    && $dbms[$i_rm]  eq  "MSSQL")    {   sqlTLog($i_rm) }
      if ($routine eq "sqlBkup"    && $dbms[$i_rm]  eq  "MSSQL")    {   sqlBkup($i_rm) }
      if ($routine eq "sqlBkupTLog" && $dbms[$i_rm]  eq  "MSSQL")    {   sqlBkupTLog($i_rm) }
      &history_dummy($i_rm) if $dbms[$i_rm] ne "Oracle";
    }

    #
    # Procs to run 
    #

    if ($runmon[$i_rm] eq "Y")   
    {
      # Non-DBMS specific subroutines
      if ($routine eq "DownloadSW") { DownloadSW($i_rm); }

      ##print "routine=$routine dbms=$dbms[$i_rm] \n";

      # SAP subroutines
      if ($routine eq "sapUp"        && $dbms[$i_rm]  eq  "SAP") {  sapUp($i_rm) }

      # OraApps subroutines
      if ($routine eq "oraapUp"      && $dbms[$i_rm]  eq  "OracleApps") {  oraapUp($i_rm) }

      # MSSQL subroutines
      if ($routine eq "sqlUp"         && $dbms[$i_rm]  eq  "MSSQL") {           sqlUp($i_rm) }
      if ($routine eq "sqlTLog"       && $dbms[$i_rm]  eq  "MSSQL") {         sqlTLog($i_rm) } 
      if ($routine eq "sqlBkup"       && $dbms[$i_rm]  eq  "MSSQL") {         sqlBkup($i_rm) } 
      if ($routine eq "sqlBkupTLog"   && $dbms[$i_rm]  eq  "MSSQL") {     sqlBkupTLog($i_rm) } 
      if ($routine eq "sqlAlerts"     && $dbms[$i_rm]  eq  "MSSQL") {       sqlAlerts($i_rm) }
      if ($routine eq "sqlFG"         && $dbms[$i_rm]  eq  "MSSQL") {           sqlFG($i_rm) }
      if ($routine eq "sqlPerf"       && $dbms[$i_rm]  eq  "MSSQL") {         sqlPerf($i_rm) }
      if ($routine eq "sqlTrends"     && $dbms[$i_rm]  eq  "MSSQL") {       sqlTrends($i_rm) }
      if ($routine eq "sqlJobs"       && $dbms[$i_rm]  eq  "MSSQL") {         sqlJobs($i_rm) }
      if ($routine eq "sqlSaveConfig" && $dbms[$i_rm]  eq  "MSSQL") {   sqlSaveConfig($i_rm) }

      # Oracle/NT subroutines
      if ($routine eq "orantUp"        && $dbms[$i_rm]  eq  "OracleNT") {        orantUp($i_rm) }
      if ($routine eq "orantPerf"      && $dbms[$i_rm]  eq  "OracleNT") {      orantPerf($i_rm) }
      if ($routine eq "orantPerf2"     && $dbms[$i_rm]  eq  "OracleNT") {     orantPerf2($i_rm) }
      if ($routine eq "orantTSFull"    && $dbms[$i_rm]  eq  "OracleNT") {    orantTSFull($i_rm) }
      if ($routine eq "orantArclog"    && $dbms[$i_rm]  eq  "OracleNT") {    orantArclog($i_rm) }
      if ($routine eq "orantDatafiles" && $dbms[$i_rm]  eq  "OracleNT") { orantDatafiles($i_rm) }
      if ($routine eq "orantBkup"      && $dbms[$i_rm]  eq  "OracleNT") {      orantBkup($i_rm) }

      # Oracle subroutines
      if ($routine eq "oraUp"         && $dbms[$i_rm]  eq  "Oracle") {        oraUp($i_rm) }
      if ($routine eq "oraSec"        && $dbms[$i_rm]  eq  "Oracle") {       oraSec($i_rm) }
      if ($routine eq "oraSaveCfg"    && $dbms[$i_rm]  eq  "Oracle") {   oraSaveCfg($i_rm) }
      if ($routine eq "oraDatafiles"  && $dbms[$i_rm]  eq  "Oracle") { oraDatafiles($i_rm) }
      if ($routine eq "oraLsnr"       && $dbms[$i_rm]  eq  "Oracle") {      oraLsnr($i_rm) }
      if ($routine eq "oraAuditSes"   && $dbms[$i_rm]  eq  "Oracle") {  oraAuditSes($i_rm) }
      if ($routine eq "oraInSync"     && $dbms[$i_rm]  eq  "Oracle") {    oraInSync($i_rm) }
      if ($routine eq "oraSGA"        && $dbms[$i_rm]  eq  "Oracle") {       oraSGA($i_rm) }
      if ($routine eq "oraTSFull"     && $dbms[$i_rm]  eq  "Oracle") {    oraTSFull($i_rm) }
      if ($routine eq "oraAlerts"     && $dbms[$i_rm]  eq  "Oracle") {    oraAlerts($i_rm) }
      if ($routine eq "oraExtents"    && $dbms[$i_rm]  eq  "Oracle") {   oraExtents($i_rm) }
      if ($routine eq "oraArclog"     && $dbms[$i_rm]  eq  "Oracle") {    oraArclog($i_rm) }
      if ($routine eq "oraBkup"       && $dbms[$i_rm]  eq  "Oracle") {      oraBkup($i_rm) }
      if ($routine eq "oraBkupArc"    && $dbms[$i_rm]  eq  "Oracle") {   oraBkupArc($i_rm) }
      if ($routine eq "oraPerf"       && $dbms[$i_rm]  eq  "Oracle") {      oraPerf($i_rm) }

      # Informix subroutines
      if ($routine eq "infLongTX"      && $dbms[$i_rm]  eq  "Informix") {      infLongTX($i_rm) }
      if ($routine eq "infCleaners"    && $dbms[$i_rm]  eq  "Informix") {    infCleaners($i_rm) }
      if ($routine eq "infChkDup"      && $dbms[$i_rm]  eq  "Informix") {      infChkDup($i_rm) }
      if ($routine eq "infHDR"         && $dbms[$i_rm]  eq  "Informix") {         infHDR($i_rm) }
      if ($routine eq "infDBS"         && $dbms[$i_rm]  eq  "Informix") {         infDBS($i_rm) }
      if ($routine eq "infSWVer"       && $dbms[$i_rm]  eq  "Informix") {       infSWVer($i_rm) }
      if ($routine eq "infUp"          && $dbms[$i_rm]  eq  "Informix") {          infUp($i_rm) }
      if ($routine eq "infSaveCfg"     && $dbms[$i_rm]  eq  "Informix") {     infSaveCfg($i_rm) }
      if ($routine eq "infMLog"        && $dbms[$i_rm]  eq  "Informix") {        infMLog($i_rm) }
      if ($routine eq "infLlogs"       && $dbms[$i_rm]  eq  "Informix") {       infLlogs($i_rm) }
      if ($routine eq "infPerf"        && $dbms[$i_rm]  eq  "Informix") {        infPerf($i_rm) }
      if ($routine eq "infChunksDown"  && $dbms[$i_rm]  eq  "Informix") {  infChunksDown($i_rm) }
      if ($routine eq "infArc"         && $dbms[$i_rm]  eq  "Informix") {         infArc($i_rm) }
      if ($routine eq "infExtents"     && $dbms[$i_rm]  eq  "Informix") {     infExtents($i_rm) }
      if ($routine eq "infLocks"       && $dbms[$i_rm]  eq  "Informix") {       infLocks($i_rm) }
      if ($routine eq "infCkpt"        && $dbms[$i_rm]  eq  "Informix") {        infCkpt($i_rm) }
      if ($routine eq "infShmem"       && $dbms[$i_rm]  eq  "Informix") {       infShmem($i_rm) }
      if ($routine eq "infNFile"       && $dbms[$i_rm]  eq  "Informix") {       infNFile($i_rm) }

      # MSSQL subroutines
      if ($routine eq "osWinUp"        && $dbms[$i_rm]  eq  "OSWin") {          &osWinUp($i_rm); }
      if ($routine eq "osWinPerf"      && $dbms[$i_rm]  eq  "OSWin") {        &osWinPerf($i_rm); }
    }

    #---- Stop timer to track time spend on this instance
    $instance_end = time();
    $instance_duration[$i_rm] += ($instance_end - $instance_start);

    #---- Log completion msg
    my $zdur = ($instance_end - $instance_start);
    &logit("RM_Done - $routine - dur=$zdur", $i_rm);

    #---- Increment host counter
    $i_rm++;
  }

  $section_end = time();
  $s_time = $section_end - $section_start;
  
  $s_array[++$s_count] = sprintf("<tr> <td> <h5> %s <td> <h5> %s <td> <h5> %s", $s_title, $s_flag , int($s_time/60));

  $wheretolog = "S";
  &logit("Section $routine Done     - Duration: $s_time second(s)");

  $msg = sprintf("---------------------------------------------------");
  &logit($msg,"",1);
  &logit("$routine - Done - Duration: $s_time second(s)","",1);
  &logit($msg,"",1);

  $routine = "";
}

#----------------------------------------------------------------------
1;
