# -----------------------------------------------------------------------------
sub sqlBkupTLog
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;

  #---- Vars
  my $this_backup_age_tlog = -1; 
  my $dbchk = ""; 

  ##print "up=$up[$thishost] title=$title[$thishost]\n"; 
  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($backup_age[$thishost] eq "" || $backup_age[$thishost] eq "N" || $backup_age_arc[$thishost] eq "N")
  {
    &logit("Backup Aging not requested for this instance (Backup_Age: and Backup_Age_TLog: parms not specified or N)",$thishost);
    return 0;
  }

  #---- Determine correct value to use based on what DBC parms were specified
  if ($backup_age_arc[$thishost] > 0)
  { 
    $this_backup_age_tlog = $backup_age_arc[$thishost]; 
  } 
  else
  { 
    $this_backup_age_tlog = $backup_age[$thishost]; 
  } 
  &logit("For all TLOG Backup Age checking for this instance, we will use a threshold of this_backup_age_tlog=$this_backup_age_tlog",$thishost);

  #---- Backup_Age "BIAS" logic - START
  $ba_bias_file = "/opt/dbamon/adm/ba_bias_MSSQL.txt";
  if (-e "$ba_bias_file")
  {
    &logit("sqlBkup.pl | Found ba_bias_file=$ba_bias_file",$thishost);
    chop($ba_bias = `cat $ba_bias_file | grep -v '^#' | head -1`);
    if ($ba_bias > 0)
    {
      $this_backup_age_tlog = $this_backup_age_tlog * $ba_bias;
      &logit("sqlBkup.pl | Backup bias value ba_bias=$ba_bias is valid - Updated this_backup_age_tlog=$this_backup_age_tlog",$thishost);
    }
  }
  #---- Backup_Age "BIAS" logic - END

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    return;
  }

  $rc = &baICheck($thishost);
  if ($rc > 0)
  {
    $bainhibit[$thishost] = 1;
    $bckhours_c[$thishost] = "black";
    $bckhours[$thishost]   = "(I)";
    $msg = sprintf("Backup Age Checking Inhibited - Start: %s End: %s Created: %s User: %s Reason: %s",$bai_sts,$bai_ets,$bai_ts,$bai_user,$bai_reason);
    &logit($msg,$thishost);
    return 0 ;
  }

  ##&remsh("$perlpath[$thishost] $probe[$thishost] bkup $run_surgery[$thishost]",$tmpfl3,$thishost);
  ##system("cat $tmpfl3");

  $maxts = "";

  #---- Don't do these 2 - sqlbkup already did
  ###$bckhours_c[$thishost] = "lime";
  my $finalage = -999;

  &logDetails($thishost,"<br><a name='sqlBkupTLOG'> <h3>MSSQL Database TLOG Backups (If Any)</h3>");
  &logDetails($thishost,"<h5>DB's: msdb, master plus all user DBs Are Being Tracked For TLOG Backup_Age IF Any TLOG Backups Have Ever Been Run</h5>");

  &logDetails($thishost,"$f_s Additionally: 
<li>Only DB's: ($backup_dbs[$thishost]) ARE being checked (if <b>Backup_Check_DBs:</b> was specified)<br>
<li>DB's: ($backup_nocheck_dbs[$thishost]) will be EXCLUDED from this check (if <b>Backup_NoCheck_DBs:</b> was specified)<br>
  <p>");

  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>$f_s
    <th>$f_s Database<br>Name
    <th>$f_s Age Of<br>Most Recent<br>TLOG <br>Backup (Hours)
    <th>$f_s Monitoring<br> Threshold<br>(Hours)
    <th>$f_s Most Recent<br>TLOG Backup<br>Timestamp
    <th>$f_s Message
  ");

  $delflag = 0;
  ##$backup_details[$thishost] = ""; 

  $lstmeth = "";

  my $max_age = -1; 

  undef %events_811;
  undef $alltext_811;

  #----   BckAgeTLOG: dbamon 18 2011-01-22 13:15:12.000 UN
  @lines = split(/\n/,$sqlBkupTLogStack[$thishost]); 
  foreach (@lines)
  {
    my $bckmsg = ""; 
    &parse; 
    
    ##print "F1=$F1 F2=$F2 F3=$F3\n";

    #---- Backup age (TLOG) data
    if ($F1 eq "BckAgeTLOG:")
    {
      $db      = $F2;
      $age     = $F3;
      $lstdate = $F4;
      $lsttime = $F5;
      $lstmeth = $F6 if $F6;

      ($lstts = $lstdate) =~ s/\-/\//g;
      $lstts .= '-' . substr($lsttime,0,8);
      $maxts = $lstts if $lstts > $maxts;


      if (
          lc $db eq "tempdb" || 
          lc $db eq "model" || 
          lc $db eq "northwind" || 
          lc $db eq "pubs" 
         )
      {
        &logit("Backup Not Applicable - Special DB=$db",$thishost);
        next;
      }

      my $db_lc = lc $db; 

      ##print "DEBUGTLOGBKUP: db=$db db_lc=$db_lc lm=$lstmeth lstts=$lstts maxts=$maxts db_attrs=$db_attrs[$thishost]{$db}\n";
      if ($db_attrs[$thishost]{$db} =~ /Snapshot/)
      {
        &logit("TLOG Backup Not Applicable - Snapshot DB=$db",$thishost);
        next;
      }
      #---- 2011/12/05 BB: If recovery model is now SIMPLE, don't proceed
      if ($db_attrs[$thishost]{$db} =~ /recoverymodel=simple/i || $db_info_tl_trunc[$thishost]{$db} =~ /yes/i)
      {
        &logit("TLOG Backup Not Applicable - RecoveryModel=SIMPLE DB=$db",$thishost);
        next;
      }

      #---- 2012/05/10 BB: If recovery model is restoring, then stop
      #---- print "DEBUG_TB - $titleraw[$thishost] - db=$db db_attrs=$db_attrs[$thishost]{$db}\n";
      if ($db_attrs[$thishost]{$db} =~ /=restoring,/i)
      {
	&logit("Backup Not Applicable - DB=$db is RESTORING",$thishost);
	next;
      }

      #---- 2012/05/22 BB: If DB is OFFLINE, then stop
      #---- print "DEBUG_TB - $titleraw[$thishost] - db=$db db_attrs=$db_attrs[$thishost]{$db}\n";
      if ($db_attrs[$thishost]{$db} =~ /=offline,/i)
      {
	&logit("Backup Not Applicable - DB=$db is OFFLINE",$thishost);
	next;
      }

      #---- 2012/06/02 BB: If DB is specified in NOCHECK, then stop
      $dbchk = lc ",$db,";
      if  (index($backup_nocheck_dbs[$thishost], $dbchk) > -1)
      {
	&logit("Backup Check Not being performed - DB=$db is found in Backup_NoCheck_DBs: ($backup_nocheck_dbs[$thishost])",$thishost);
	next;
      }

      #---- Vars
      $zd = $lstdate;
      $zd =~ s/-/\//g;
      $zt = substr($lsttime,0,8);
      $zts = "$zd-$zt";
      $zts = "(Never)" if $zts eq "-";

      #if ($delflag == 0) 
      #{
      #	# Delete old data for this server
      #	$sqlstmt = "delete from dbamon.mssql_backup where server = '$titleraw[$thishost]'";
      #	&runSQL($sqlstmt);
      #        $delflag = 1;
      #      }
      #
      #      # insert a new row for this db;
      #      $sqltext  = "insert into dbamon.mssql_backup (dbamonmode,server,db,bkage,bkts,dbcfile) \n";
      #
      #      $age = -1 if $age eq "";
      #
      #      $sqltext .= "values ('$modeout', 
      #			     '$titleraw[$thishost]',
      #			     '$db',
      #			     '$age', 
      #			     '$zts',
      #			     '$dbcfile[$thishost]'
      #			     )";
      #      &runSQL($sqltext);
      #      ##print "inserted $sqltext\n";

      next if $this_backup_age_tlog eq "";   #---- Huh? How could this happen?

      # Just in case we exceed, set these vars and make report
      $rounded1 = int($age / 10);
      $rounded1 = $rounded1 * 10;
      $rounded2 = $rounded1 + 9;

      #---- Save this for later  
      if ($age > $max_age)
      {
        $max_age = $age; 
        $max_range = "${rounded1}-${rounded2}";
        $mr_age_arc[$thishost] = $max_age; 
      }

      $dbchk = ",$db,";
      print "-- found db=$db age=$age bat=$this_backup_age_tlog bcd=$backup_dbs[$thishost] dbchk=$dbchk\n" if $debug_22;

      $bck_msg = "";

      $rerun = 0;
      $bcksev = "C";
      $bckcolor = "lime";
      $bckrerun_msg = "";

      #---- perf - 2011/13/19 BB: Not needed any more
      # open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
      # print TMPFL6 "---------------------------------------------------\n";
      # print TMPFL6 "Most recent successful L backup of database: $db\n";
      # print TMPFL6 "Date: $lstdate \n";
      # print TMPFL6 "Time: $lsttime \n";
      # print TMPFL6 "---------------------------------------------------\n";
      # print TMPFL6 "\nAll Registered Backups For Database: $db \n"; 
      # print TMPFL6 "<table border=1> \n ";
      # print TMPFL6 "<tr bgcolor=$table_headbgcolor><th>$f_s Database Name<th>$f_s Backup Timestamp<th>$f_s Backup Type<th>$f_s Age (Hours)</tr>\n";
      # ##print "cat $tmpfl3 | grep '<tr' | grep '$db' \n";
      # ##system("cat $tmpfl3 | grep '<tr' | grep '$db' ");
      # print TMPFL6 `cat $tmpfl3 | grep '<td>$db '`;
      # print TMPFL6 "</table> \n";
      # close(TMPFL6);

      #---- OLD - 5.30
      #if (index($backup_dbs[$thishost],lc $dbchk) > -1 || lc $db eq "master" || lc $db eq "msdb" || $backup_dbs[$thishost] eq ",all,")
      #---- NEW - 5.30 - Now if Backup_Check_DBs: is NOT specified, we will check all DBs by default
      if  (index(lc $backup_dbs[$thishost],lc $dbchk) > -1 || 
           lc $db eq "master" || 
           lc $db eq "msdb"   || 
           $backup_dbs[$thishost] eq ",all," || 
           $backup_dbs[$thishost] eq "")
      {
        if (index(lc $backup_nocheck_dbs[$thishost],lc $dbchk) > -1)  
        {
          &logit("  DB=$db EXCLUDED (Backup_NoCheck_DBs:)",$thishost);
        }
        else
        {
	  if ($age > $finalage) { $finalage = $age; }

	  #print "  DB HIT #1 db=$db dbchk=$cbchk iter_count=$iter_count backup_rerun_iter[$thishost]=$backup_rerun_iter[$thishost]\n" if $debug_22; 
	  #print "  DB HIT #2 age=$age backup_age[$thishost]=$backup_age[$thishost]\n" if $debug_22; 

	  &metricsCurrent("sqlBkupTLog()",$thishost,"BACKUP_AGE_TLOG",$db,$age,"",$this_backup_age_tlog ,"Hours since last good TLOG Backup for this DB: $age");

	  if ($age == -1)
	  {
            $ev_cat = "Bkup";
	    &event($bcksev,$thishost,"MSSQL DB=$db - Backup Never Run - Threshold=$this_backup_age_tlog $bckrerun_msg","BkpNever","DBA810$bcksev",$tmpfl6);
	    $bckmsg = "No Backup Ever"; 
	    $bckcolor = "pink"; 
	  }
	  elsif ($age > $this_backup_age_tlog)
	  {
	    # Cache this 811 event
	    $z = sprintf("DB: %-20s - Hours since last good TLOG backup: %4d\n",$db,$age);
	    $events_811{"$bcksev-$rounded1-$rounded2"} .= $z; 
	    $alltext_811                               .= $z; 
	    $bckhours_c[$thishost] = $bckcolor;
	    $bckmsg = "Event - Backup Age Threshold of $this_backup_age_tlog Hours Exceeded";
	    $bckcolor = "pink"; 
	    $bckhours_c[$thishost] = "red";
	  }
	  else
	  {
	    &logit("OK - DB=$db Age=$age Threshold=$thishost",$thishost);
	    $bckmsg = "OK - Backup Age Threshold of $this_backup_age_tlog Hours NOT Exceeded";
	    $bckcolor = "lime"; 
	  }
        }
      }

      if ($age == -1) { $zage = "<b>(Never)</b>"; }
      else            { $zage = $age; }

      &logDetails($thishost,"<tr bgcolor=$bckcolor>
        <td>$f_s <b> $db </b> 
        <td align=right>$f_s $zage
        <td align=right>$f_s $this_backup_age_tlog 
        <td>$f_s $lstdate $lsttime
        <td>$f_s <b> $bckmsg </b>");

      #---- Pointless
      ## &histCreate("sqlBkup()",$thishost,"BCKAGE_L",$db,$age,$backup_age[$thishost]);

      &metricsInsert("sqlBkup()",$thishost,"BCKAGE_L",$db,$age);
    }
  }
  close(TMPFL3);

  &logDetails($thishost,"</table><hr>");

  $bckhours[$thishost] = $finalage;
  if ($bckhours[$thishost] == -1) { $bckhours[$thishost] = "(Never)" }

  print "sqlBkup - $titleraw[$thishost] lstmeth=[$lstmeth]\n" if $debug_22;

  #---- We already did this in SQLBKUP
  #if    ($lstmeth eq "D" ) { $backup_method_long[$thishost] = "bkDISK"; }
  #elsif ($lstmeth eq "V" ) { $backup_method_long[$thishost] = "bkVERITAS"; }
  #elsif ($lstmeth eq "OB") { $backup_method_long[$thishost] = "bkOMNIBACK"; }
  #elsif ($lstmeth eq "UN") { $backup_method_long[$thishost] = "bkUnknown"; }
  #else                     { $backup_method_long[$thishost] = ""; }

  $mr_backup_date[$thishost] = $maxts; 

  #---- Create events for any cached 811's

  undef %posted_811;
  
  foreach (sort keys %events_811)
  {
    $key   = $_;
    $sev   = substr($key,0,1); 
    $range = substr($key,2); 
    $text  = $events_811{"$key"};

    $range_lower    = (split(/\-/,$key)) [1];
    $range_pct_of_t = int($range_lower / $this_backup_age_tlog) * 100 if $this_backup_age_tlog > 0;
    if ($range_pct_of_t > 200)
    {
      $this_pri = "H"; 
    }
    else
    {
      $this_pri = undef;
    }

    ##print "DEBUG - Event: 811 - key=$key sev=$sev range_lower=$range_lower range_pct_of_t=$range_pct_of_t t=$backup_age[$thishost] this_pri=$this_pri\n";

    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL2 "$dashes\n\n";
    print TMPFL2 "------- Report of Databases Which Needed To Be Backed Up -------\n\n";
    print TMPFL2 "$alltext_811\n";
    print TMPFL2 "$dashes\n\n";

    #---- Don't do this any more
    # print TMPFL2 "------- Probe Raw Data -------\n\n";
    # print TMPFL2 &fileReadScalar($tmpfl3);

    close(TMPFL2);

    if (! $posted_811{$sev}) 
    {
      #---- Old
      ## &event($sev,$thishost,"$max_range Hours since last TLOG backup for at least 1 DB - Threshold is $backup_age[$thishost] hours","BkpAge","DBA811",$tmpfl2,undef,undef,$this_pri);
      #---- New
      $ev_cat = "Bkup";
      &event($sev,$thishost,"More than $this_backup_age_tlog Hours Since Last Good TLOG Backup for at least 1 DB (Threshold: $this_backup_age_tlog hours)","BkpAge-TLog","DBA811",$tmpfl2,undef,undef,$this_pri);
    }
    $posted_811{$sev} = 1;
  }

  ##print "lm=$lstmeth bml=$backup_method_long[$thishost]\n";
  ##print "DEBUG - sqlBkupTLog - bckhours_c[$thishost]=$bckhours_c[$thishost]\n";

  if ($short eq "")
  {
    $msg = sprintf("OK (%s/%s)",$finalage,$this_backup_age_tlog);
    &logit($msg,$thishost);
  }

  #---- Save these for the summarize routine
  $bckhours_color_tlog[$thishost] = $bckhours_c[$thishost];
  $bckhours_value_tlog[$thishost] = $bckhours[$thishost];
}
# -----------------------------------------------------------------------------
1;
